<!DOCTYPE html>
<html>
<head>
    <title>MWO Skills Grid</title>
    <link rel="stylesheet" href="grid.css"/>
    <link rel="icon" href="favicon.ico"/>
    <script src="hexagon.js"></script>
    <script src="skill-map.js"></script>
    <script src="skills.js"></script>
    <script>
    if ('##ANALYTICS_ID##' && '##ANALYTICS_ID##' != ('##' + 'ANALYTICS_ID' + '##')) {
      (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
      (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
      m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
      })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
      ga('create', '##ANALYTICS_ID##', 'auto'); ga('send', 'pageview');
    }
    </script>
</head>
<body>
    <div id="LeftPane">
        <div id="Header">mwoSkill</div>
        <div id="GeneralInfo">loading</div>
        <div id="NavPane"></div>
        <div id="Footer">
            <a href="javascript:;" id="showhelp">welcome and info?</a><br/>
            <a href="https://gitlab.com/kitlaan/mwoskill">mwoskill code</a><br/>
            <a href="https://kitlaan.gitlab.io/mwodata/mechquirks.html">mech quirks list</a><br/>
            <a href="https://www.patreon.com/kitlaan">patreon</a><br/>
            <a href="https://paypal.me/tedmlin">paypal</a>
        </div>
    </div>
    <div id="Display" style="width: 1270px; height: 810px">
        <canvas id="HexCanvas" width="1270" height="810"></canvas>
        <canvas id="LineCanvas" width="1270" height="810"></canvas>
    </div>
    <div id="MechPane">
        <select id="factionSelect"><option selected>IS</option><option>Clan</option></select>
        <select id="weightSelect"><option>Light</option><option>Medium</option>
            <option selected>Heavy</option><option>Assault</option></select>
    </div>
    <div id="ImportPane">
        <div class="button" id="importmwo">Import MWO</div>
        <div class="button" id="exportmwo">Export MWO</div>
    </div>
    <div id="ButtonPane">
        <div class="button" id="selectallnodes">Select All Nodes</div>
        <div class="button" id="clearnodes">Clear All Nodes</div>
        <div class="button" id="cleareverything">Clear Everything</div>
        <div class="button" id="toggledisabled">Toggle Visibility</div>
    </div>
    <div id="InfoPane">
        <a href="#" download="mwoskill.png" id="downloader" class="button">Download All Sections to PNG</a>
        <div class="button" id="permlink">Get PermLink</div>
        <br/>
        <div><span id="NodesUnlocked">0</span> unlocked nodes</div>
        <table id="QuirkRollup"></table>
        <br/>
        <div>
            UNDER CONSTRUCTION
        </div>
    </div>
    <div id="SelectVersionModal" class="modal">
        <div class="modalContent">
            <span class="close">&times;</span>
            <p>Switch to another Skill Tree release version.</p>
            <select id="SkillVersions"></select>
            <input id="SkillVersionsButton" type="button" value="OK"/>
        </div>
    </div>
    <div id="HelpModal" class="modal">
        <div class="modalContent">
            <span class="close">&times;</span>
            <p>MechWarrior Online skill tree helper. Hopefully this tool
            proves useful to you in planning out your skill selection.</p>
            <p>Here's some features you may not find on your own:</p>
            <ul>
                <li>hold down left-click &mdash; keep toggling as you move</li>
                <li>shift-click &mdash; toggle all cells of the same type</li>
                <li>right-click, save-as &mdash; save just the one section to PNG</li>
                <li>click on version number &mdash; change MWO patch version</li>
                <li>permlink, then download all &mdash; embed the permlink in PNG</li>
            </ul>
            <p>Currently using free JSON hosting (jsonblob.com or jsonbin.io),
            sorry for any inconvenience if things are down.</p>
        </div>
    </div>
    <div id="GeneralModal" class="modal">
        <div class="modalContent">
            <span class="close">&times;</span>
            <div id="generalContent"></div>
        </div>
    </div>
    <script>
        var hexagonGrid = new HexagonGrid(document.getElementById("HexCanvas"), 45, 18);
        var lineGrid = new HexagonGrid(document.getElementById("LineCanvas"), 45, 18);

        var skills = new MwoSkills(hexagonGrid, lineGrid);

        hexagonGrid.bindListener('contextmenu', skills.mirrorEvent, skills);
        hexagonGrid.bindListener("mousedown", skills.clickEventHexGrid, skills);
        hexagonGrid.bindListener("mousemove", skills.mousemoveEventHexGrid, skills);

        skills.makeModal("SelectVersionModal", "GeneralInfo");
        skills.makeModal("HelpModal", "showhelp");

        function getUrlParameter(name) {
            name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
            var regex = new RegExp('[\\?#&]' + name + '=([^&#]*)');

            var search = regex.exec(location.search);
            if (search != null) {
                return decodeURIComponent(search[1].replace(/\+/g, ' '));
            }

            var hash = regex.exec(location.hash);
            if (hash != null) {
                return decodeURIComponent(hash[1].replace(/\+/g, ' '));
            }

            return '';
        };

        var skillJson = getUrlParameter('file');
        if (!skillJson) {
            skillJson = "skills-20200630.json";
        }

        var mwohash = getUrlParameter('h');
        var presetJson = getUrlParameter('p');
        var sectionJson = getUrlParameter('s');

        skills.initialize(presetJson, sectionJson, mwohash);
        skills.loadSkills(skillJson);
    </script>
</body>
</html>
